// sier2Doc.cpp : implementation of the CSier2Doc class
//

/*
   This is a stock Application Wizard created Microsoft Foundation
   Class file except for the Serialize function which has been
   modified to write out the Sierpinski pyramid in DXF formation when
   the SaveAs menu item is selected from the File pull down menu.
 */

#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>

#include "sier2.h"

#include "sier2Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSier2Doc

IMPLEMENT_DYNCREATE(CSier2Doc, CDocument)

BEGIN_MESSAGE_MAP(CSier2Doc, CDocument)
	//{{AFX_MSG_MAP(CSier2Doc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSier2Doc construction/destruction

CSier2Doc::CSier2Doc()
{
	// TODO: add one-time construction code here

}

CSier2Doc::~CSier2Doc()
{
}

BOOL CSier2Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/*
 * CSier2Doc::Serialize
 *

   Write the Sierpinski pyramid to a file, in AutoDesk DXF file format
   (using 3DFACE entities).  

   The advantage of doing the write from Serialize is that MFC sets
   up the file browser dialog, opens the file and warns the user if
   the file already exists.  Only the code to do the actual write
   needs to be added here.

   This function is called by the default OnSaveFileAs logic that
   is built into MFC.  MFC opens the file for unbuffered reads and
   writes.  This is incompatible with the buffered stream I/O used
   to write out the Sierpinski pyramid.  The first thing that is
   done is to convert the low level file pointer into a stream
   based file pointer.  The functions to do this are obscure and
   are only documented in the Microsoft Knowledge Base and in a few
   articles that come with the Developer Library CD-ROM.

 */
void CSier2Doc::Serialize(CArchive& ar)
{
  if (ar.IsStoring()) { // storing
    // get the low level file pointer.
    CFile *cfile_fp = ar.GetFile();

    // Get the operating system file handle
    int os_file_handle = cfile_fp->m_hFile;
    
    // Convert the operating system file handle into a handle that
    // is compatible with POSIX style stream I/O.  This handle
    // is the same handle that is returned by the POSIX open()
    // call.  Note that the file is opened "write only"
    int crt_handle = _open_osfhandle( os_file_handle, _O_WRONLY );

    // Convert the unbuffered POSIX style handle into a buffered 
    // file pointer.
    FILE *fp = _fdopen( crt_handle, "w" );
   
    // Write the pyramid out in DXF format
    PyrPtr->pyr_write( fp );

    // The close operation that is performed by MFC does a low
    // level close and does not flush the buffers, so flush them
    // here.
    fflush( fp );
  }
  else { // loading
    // this should never happen
    AfxMessageBox("CSier2Doc::Serialize: no load function implemented");
  }
}

/////////////////////////////////////////////////////////////////////////////
// CSier2Doc diagnostics

#ifdef _DEBUG
void CSier2Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CSier2Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSier2Doc commands
